//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 DeepSkyBlue
#property indicator_color2 PaleVioletRed
#property indicator_color3 PaleVioletRed
#property indicator_width3 2
#property indicator_level1 50

//
//
//
//
//

extern int StochK       = 14;
extern int StochSlowing =  3;
extern int SignalEma    =  9;
extern int Price        =  0;

//
//
//
//
//

double upBuffer[];
double dnBuffer[];
double miBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,upBuffer);
   SetIndexBuffer(1,dnBuffer);
   SetIndexBuffer(2,miBuffer);
   IndicatorShortName("ema levels - stochastic ("+StochK+","+StochSlowing+","+SignalEma+")");
   return(0);
}
int deinit() {}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int limit,i,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   double alpha = 2.0 / (1.0 + SignalEma);
   for(i=limit; i>=0; i--)
   {
      miBuffer[i] = iStochastic(NULL,0,StochK,1,StochSlowing,MODE_SMA,Price,MODE_MAIN,i);
      upBuffer[i] = upBuffer[i+1];
      dnBuffer[i] = dnBuffer[i+1];
         
         if (miBuffer[i]>50) upBuffer[i] = upBuffer[i+1]+alpha*(miBuffer[i]-upBuffer[i+1]);
         if (miBuffer[i]<50) dnBuffer[i] = dnBuffer[i+1]+alpha*(miBuffer[i]-dnBuffer[i+1]);
   }
   return(0);
}

